local OW = unpack(select(2, ...))  -->Engine
local E, C, F, L = unpack(Quafe)  -->Engine, Config, Function, Locale

----------------------------------------------------------------
--> API and Variable
----------------------------------------------------------------

local _G = getfenv(0)
local format = string.format
local find = string.find

local min = math.min
local max = math.max
local format = string.format
local floor = math.floor
local sqrt = math.sqrt
local sin = math.sin
local asin = math.asin
local cos = math.cos
local acos = math.acos
local tan = math.tan
local atan = math.atan
local rad = math.rad
local modf = math.modf
local GetTime = _G.GetTime

----------------------------------------------------------------
--> Minimap
----------------------------------------------------------------

local TAN_4 = format("%.2f",tan(rad(4)))

local NUM_40 = {
    [0] = {20,   2/512, 42/512},
    [1] = {16,  46/512, 78/512},
    [2] = {20,  90/512,130/512},
    [3] = {20, 134/512,174/512},
    [4] = {20, 178/512,218/512},
    [5] = {20, 222/512,262/512},
    [6] = {20, 266/512,306/512},
    [7] = {20, 310/512,350/512},
    [8] = {20, 354/512,394/512},
    [9] = {20, 398/512,438/512},
    ["%"] = {18, 442/512,478/512},
    ["N"] = {4, 511/512,512/512},
}

local function Minimap_Border_S(frame)
	local Bd = CreateFrame("Frame", nil, frame)
	Bd: SetSize(83,61)
	Bd: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -70,70*TAN_4-1)

	local Bd1 = Bd: CreateTexture(nil, "ARTWORK")
	Bd1: SetTexture(OW.Path("Minimap_Bd4"))
	Bd1: SetSize(83,61)
	Bd1: SetTexCoord(1/1024,167/1024,345/512,467/512)
	Bd1: SetAlpha(1)
	Bd1: SetVertexColor(243/255, 244/255, 246/255)
	Bd1: SetPoint("CENTER")

	local Bd1Sd = Bd: CreateTexture(nil, "BACKGROUND")
	Bd1Sd: SetTexture(OW.Path("Minimap_Bd4"))
	Bd1Sd: SetSize(83,61)
	Bd1Sd: SetTexCoord(169/1024,335/1024,345/512,467/512)
	Bd1Sd: SetAlpha(0.4)
	Bd1Sd: SetVertexColor(F.Color(C.Color.Main0))
	Bd1Sd: SetPoint("CENTER")

	local Bd2 = Bd: CreateTexture(nil, "BORDER")
	Bd2: SetTexture(OW.Path("Minimap_Bd4"))
	Bd2: SetSize(83,61)
	Bd2: SetTexCoord(337/1024,503/1024,345/512,467/512)
	Bd2: SetAlpha(1)
	Bd2: SetVertexColor(243/255, 244/255, 246/255)
	Bd2: SetPoint("CENTER")

	return Bd
end

local function Minimap_Border_M(frame)
	local Bd = CreateFrame("Frame", nil, frame)
	Bd: SetSize(160,116) --322,234
	Bd: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -48,48*TAN_4+2)

	local Bd1 = Bd: CreateTexture(nil, "ARTWORK")
	Bd1: SetTexture(OW.Path("Minimap_Bd2"))
	Bd1: SetSize(160,116)
	Bd1: SetTexCoord(1/1024,321/1024,1/256,233/256)
	Bd1: SetAlpha(1)
	Bd1: SetVertexColor(243/255, 244/255, 246/255)
	Bd1: SetPoint("CENTER")

	local Bd1Sd = Bd: CreateTexture(nil, "BACKGROUND")
	Bd1Sd: SetTexture(OW.Path("Minimap_Bd2"))
	Bd1Sd: SetSize(160,116)
	Bd1Sd: SetTexCoord(323/1024,643/1024,1/256,233/256)
	Bd1Sd: SetAlpha(0.4)
	Bd1Sd: SetVertexColor(F.Color(C.Color.Main0))
	Bd1Sd: SetPoint("CENTER")

	local Bd2 = Bd: CreateTexture(nil, "BORDER")
	Bd2: SetTexture(OW.Path("Minimap_Bd2"))
	Bd2: SetSize(160,116)
	Bd2: SetTexCoord(645/1024,965/1024,1/256,233/256)
	Bd2: SetAlpha(1)
	Bd2: SetVertexColor(243/255, 244/255, 246/255)
	Bd2: SetPoint("CENTER")

	return Bd
end

local function Minimap_Border_L(frame)
	local Bd = CreateFrame("Frame", nil, frame)
	Bd: SetSize(235,171)
	Bd: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -26,26*TAN_4+3)

	local Bd1 = Bd: CreateTexture(nil, "ARTWORK")
	Bd1: SetTexture(OW.Path("Minimap_Bd3"))
	Bd1: SetSize(235,171)
	Bd1: SetTexCoord(1/1024,471/1024,1/512,343/512)
	Bd1: SetAlpha(1)
	Bd1: SetVertexColor(243/255, 244/255, 246/255)
	Bd1: SetPoint("CENTER")

	local Bd1Sd = Bd: CreateTexture(nil, "BACKGROUND")
	Bd1Sd: SetTexture(OW.Path("Minimap_Bd3"))
	Bd1Sd: SetSize(235,171)
	Bd1Sd: SetTexCoord(473/1024,943/1024,1/512,343/512)
	Bd1Sd: SetAlpha(0.4)
	Bd1Sd: SetVertexColor(F.Color(C.Color.Main0))
	Bd1Sd: SetPoint("CENTER")

	local Bd2 = Bd: CreateTexture(nil, "BORDER")
	Bd2: SetTexture(OW.Path("Minimap_Bd4"))
	Bd2: SetSize(235,171)
	Bd2: SetTexCoord(1/1024,471/1024,1/512,343/512)
	Bd2: SetAlpha(1)
	Bd2: SetVertexColor(243/255, 244/255, 246/255)
	Bd2: SetPoint("CENTER")

	return Bd
end

local function MinimapButton_Template(frame)
	local Button = CreateFrame("Button", nil, frame)
	Button: SetSize(44,32)

	local Bg = Button: CreateTexture(nil, "BORDER")
	Bg: SetTexture(OW.Path("Minimap_Bd5"))
	Bg: SetSize(44,32)
	Bg: SetTexCoord(2/256,90/256, 1/128,65/128)
	Bg: SetVertexColor(243/255, 244/255, 246/255)
	Bg: SetAlpha(0.6)
	Bg: SetPoint("CENTER")

	local Sd = Button: CreateTexture(nil, "BACKGROUND")
	Sd: SetTexture(OW.Path("Minimap_Bd5"))
	Sd: SetSize(44,32)
	Sd: SetTexCoord(94/256,182/256, 1/128,65/128)
	Sd: SetVertexColor(F.Color(C.Color.Main0))
	Sd: SetAlpha(0.4)
	Sd: SetPoint("CENTER")

	local Flash = CreateFrame("Frame", nil, Button, "OW_GarrisonNotificationTemplate")
	Flash: SetSize(44,32)
	Flash: SetFrameLevel(Button:GetFrameLevel())
	Flash: SetPoint("CENTER")
	Flash: Hide()

	local FlashTexture = Flash: CreateTexture(nil, "ARTWORK")
	FlashTexture: SetTexture(OW.Path("Minimap_Bd5"))
	FlashTexture: SetSize(44,32)
	FlashTexture: SetTexCoord(2/256,90/256, 1/128,65/128)
	FlashTexture: SetVertexColor(F.Color(C.Color.Y1))
	FlashTexture: SetAlpha(1)
	FlashTexture: SetPoint("CENTER")

	local Hold = CreateFrame("Frame", nil, Button)
	Hold: SetSize(32,22)
	Hold: SetPoint("CENTER")

	local Icon = Button: CreateTexture(nil, "ARTWORK")
	Icon: SetVertexColor(F.Color(C.Color.Main0))
	Icon: SetAlpha(0.75)
	Icon: SetPoint("CENTER")

	Button.Bg = Bg
	Button.Icon = Icon
	Button.Flash = Flash

	return Button
end

local function Mail_Template(frame)
	local Mail = MinimapButton_Template(frame)
	Mail: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -102,102*TAN_4-42)

	Mail.Icon: SetTexture(OW.Path("Minimap_Bd5"))
	Mail.Icon: SetSize(32,22)
	Mail.Icon: SetTexCoord(186/256,250/256, 1/128,45/128)

	Mail: RegisterEvent("UPDATE_PENDING_MAIL")
	Mail: RegisterEvent("PLAYER_ENTERING_WORLD")
	Mail: SetScript("OnEvent", function(self,event)
		if event == "PLAYER_ENTERING_WORLD" then
			self: UnregisterEvent("PLAYER_ENTERING_WORLD")
		end
		if ( HasNewMail() ) then
			self.Icon: SetAlpha(1.0)
			self.Flash: Show()
			if( GameTooltip: IsOwned(self) ) then
				MinimapMailFrameUpdate()
			end
		else
			self.Icon: SetAlpha(0.5)
			self.Flash: Hide()
		end
	end)
	
	Mail: SetScript("OnEnter", function(self)
		GameTooltip: SetOwner(self, "ANCHOR_TOP")
		self.Flash: Hide()
		if( GameTooltip:IsOwned(self) ) then
			if ( HasNewMail() ) then
				MinimapMailFrameUpdate()
			else
				GameTooltip: SetText(L['NO_MAIL'])
			end
		end
	end)
	Mail: SetScript("OnLeave", function(self)
		GameTooltip: Hide()
	end)

	return Mail
end

local function InstanceDifficulty_Template(frame)
	local Instance = MinimapButton_Template(frame)
	Instance: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -146,146*TAN_4-42)

	Instance.Icon: SetTexture(OW.Path("Minimap_Bd5"))
	Instance.Icon: SetSize(32,22)
	Instance.Icon: SetTexCoord(186/256,250/256, 47/128,91/128)

	Instance: SetScript("OnEnter", function(self)
		self.Icon: SetAlpha(1)
	end)
	Instance: SetScript("OnLeave", function(self)
		self.Icon: SetAlpha(0.75)
		GameTooltip:Hide();
	end)

	local InstanceHold = CreateFrame("Frame", nil, Instance)
	InstanceHold: SetAllPoints(Instance)

	if not F.IsClassic then
		QueueStatusMinimapButton: SetParent(InstanceHold)
		QueueStatusMinimapButton: ClearAllPoints()
		QueueStatusMinimapButton.ClearAllPoints = function() end
		QueueStatusMinimapButton: SetPoint("CENTER", InstanceHold, "CENTER", 0, 0)
		QueueStatusMinimapButton: SetFrameStrata(InstanceHold:GetFrameStrata())
		QueueStatusMinimapButton: SetFrameLevel(InstanceHold:GetFrameLevel()+1)
		QueueStatusMinimapButton.SetPoint = function() end
		QueueStatusMinimapButtonBorder: Hide()
		
		QueueStatusMinimapButton: SetHighlightTexture("") 
		QueueStatusMinimapButtonIcon: SetSize(32,32)
		QueueStatusMinimapButtonIconTexture: SetTexture(OW.Path("InstanceEye"))
	end
end

local function Garrison_UpdateIcon(frame)
	frame.GarrisonType = C_Garrison.GetLandingPageGarrisonType();
	if (frame.GarrisonType == LE_GARRISON_TYPE_6_0) then
		frame.title = GARRISON_LANDING_PAGE_TITLE;
		frame.description = MINIMAP_GARRISON_LANDING_PAGE_TOOLTIP;
	elseif (frame.GarrisonType == LE_GARRISON_TYPE_7_0) then
		frame.title = ORDER_HALL_LANDING_PAGE_TITLE;
		frame.description = MINIMAP_ORDER_HALL_LANDING_PAGE_TOOLTIP;
	elseif (frame.GarrisonType == LE_GARRISON_TYPE_8_0) then
		frame.title = GARRISON_TYPE_8_0_LANDING_PAGE_TITLE;
		frame.description = GARRISON_TYPE_8_0_LANDING_PAGE_TOOLTIP;
	end
end

local function Garrison_Template(frame)
	if F.IsClassic then return end
	local Garrison = MinimapButton_Template(frame)
	Garrison: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -190,190*TAN_4-42)

	Garrison.Icon: SetTexture(OW.Path("Minimap_Bd5"))
	Garrison.Icon: SetSize(32,22)
	Garrison.Icon: SetTexCoord(117/256,183/256, 67/128,111/128)

	Garrison: SetScript("OnEnter", function(self)
		self.Icon: SetAlpha(1)
		if self.title and self.description then
			GameTooltip:SetOwner(self, "ANCHOR_TOP");
			GameTooltip:SetText(self.title, 1, 1, 1);
			GameTooltip:AddLine(self.description, nil, nil, nil, true);
			GameTooltip:Show();
		end
	end)
	Garrison: SetScript("OnLeave", function(self)
		self.Icon: SetAlpha(0.75)
		GameTooltip:Hide();
	end)

	Garrison: SetScript("OnClick", function(self, button)
		GarrisonLandingPage_Toggle()
		--GarrisonTabButton_Refresh(self)
	end)

	Garrison: RegisterEvent("GARRISON_SHOW_LANDING_PAGE")
	Garrison: RegisterEvent("GARRISON_HIDE_LANDING_PAGE")
	Garrison: RegisterEvent("GARRISON_BUILDING_ACTIVATABLE")
	Garrison: RegisterEvent("GARRISON_BUILDING_ACTIVATED")
	Garrison: RegisterEvent("GARRISON_TALENT_COMPLETE")
	Garrison: RegisterEvent("GARRISON_ARCHITECT_OPENED")
	Garrison: RegisterEvent("GARRISON_MISSION_FINISHED")
	Garrison: RegisterEvent("GARRISON_MISSION_NPC_OPENED")
	Garrison: RegisterEvent("GARRISON_SHIPYARD_NPC_OPENED")
	Garrison: RegisterEvent("GARRISON_INVASION_AVAILABLE")
	Garrison: RegisterEvent("GARRISON_INVASION_UNAVAILABLE")
	Garrison: RegisterEvent("SHIPMENT_UPDATE")
	Garrison: SetScript("OnEvent", function(self, event, ...)
		if (event == "GARRISON_HIDE_LANDING_PAGE") then
			--self.Flash: Show()
			--Garrison_UpdateIcon(self)
		elseif (event == "GARRISON_SHOW_LANDING_PAGE") then
			Garrison_UpdateIcon(self)
			--self.Flash: Hide()
		elseif ( event == "GARRISON_BUILDING_ACTIVATABLE" ) then
			self.Flash: Show()
		elseif ( event == "GARRISON_BUILDING_ACTIVATED" or event == "GARRISON_ARCHITECT_OPENED") then
			self.Flash: Hide()
		elseif ( event == "GARRISON_TALENT_COMPLETE") then
			self.Flash: Show()
		elseif ( event == "GARRISON_MISSION_FINISHED" ) then
			self.Flash: Show()
		elseif ( event == "GARRISON_MISSION_NPC_OPENED" ) then
			self.Flash: Hide()
		elseif ( event == "GARRISON_SHIPYARD_NPC_OPENED" ) then
			self.Flash: Hide()
		elseif (event == "GARRISON_INVASION_AVAILABLE") then
			self.Flash: Show()
		elseif (event == "GARRISON_INVASION_UNAVAILABLE") then
			self.Flash: Hide()
		elseif (event == "SHIPMENT_UPDATE") then
			local shipmentStarted, isTroop = ...
			if (shipmentStarted) then
				self.Flash: Show()
			end
		end
	end)

	hooksecurefunc("GarrisonMinimap_ClearPulse", function()
		Garrison.Flash: Hide()
	end)
end

local function Minimap_Template(frame)
    local Anchor = CreateFrame("Frame", nil, frame)
    Anchor: SetSize(36,64)

    local Bd1 = Anchor: CreateTexture(nil, "ARTWORK")
    Bd1: SetVertexColor(31/255, 174/255, 255/255)
    Bd1: SetAlpha(1)
    Bd1: SetTexture(OW.Path("Minimap_Bd1"))
    Bd1: SetPoint("CENTER", Anchor, "CENTER")
    Bd1: SetSize(36,64)
    Bd1: SetTexCoord(2/256,74/256, 2/256,130/256)

    local Bd1Sd = Anchor: CreateTexture(nil, "BACKGROUND")
    Bd1Sd: SetVertexColor(F.Color(C.Color.Main0))
    Bd1Sd: SetAlpha(0.4)
    Bd1Sd: SetTexture(OW.Path("Minimap_Bd1"))
    Bd1Sd: SetPoint("CENTER", Bd1, "CENTER")
    Bd1Sd: SetSize(36,64)
    Bd1Sd: SetTexCoord(78/256,150/256, 2/256,130/256)

	local Sizer = CreateFrame("Button", nil, Anchor)
	Sizer: SetSize(49,38)
	Sizer: SetPoint("BOTTOMRIGHT", Anchor, "BOTTOMRIGHT", -31,31*TAN_4)
	Sizer: SetAlpha(0.9)

	local SizerIcon1 = Sizer: CreateTexture(nil, "BORDER")
	SizerIcon1: SetVertexColor(243/255, 244/255, 246/255)
    SizerIcon1: SetAlpha(1)
    SizerIcon1: SetTexture(OW.Path("Minimap_Bd1"))
    SizerIcon1: SetPoint("CENTER", Sizer, "CENTER")
    SizerIcon1: SetSize(49,38)
    SizerIcon1: SetTexCoord(154/256,252/256, 2/256,78/256)

	local SizerIcon1Sd = Sizer: CreateTexture(nil, "BACKGROUND")
	SizerIcon1Sd: SetVertexColor(F.Color(C.Color.Main0))
    SizerIcon1Sd: SetAlpha(0.4)
    SizerIcon1Sd: SetTexture(OW.Path("Minimap_Bd1"))
    SizerIcon1Sd: SetPoint("CENTER", Sizer, "CENTER")
    SizerIcon1Sd: SetSize(49,38)
    SizerIcon1Sd: SetTexCoord(154/256,252/256, 82/256,158/256)

	local SizerIcon2 = Sizer: CreateTexture(nil, "ARTWORK")
	SizerIcon2: SetVertexColor(F.Color(C.Color.Main0))
    SizerIcon2: SetAlpha(1)
    SizerIcon2: SetTexture(OW.Path("Minimap_Bd1"))
    SizerIcon2: SetPoint("CENTER", Sizer, "CENTER")
    SizerIcon2: SetSize(49,38)
    SizerIcon2: SetTexCoord(52/256,150/256, 162/256,238/256)

	local SizerIcon2Sd = Sizer: CreateTexture(nil, "ARTWORK")
	SizerIcon2Sd: SetVertexColor(F.Color(C.Color.Main0))
    SizerIcon2Sd: SetAlpha(0)
    SizerIcon2Sd: SetTexture(OW.Path("Minimap_Bd1"))
    SizerIcon2Sd: SetPoint("CENTER", Sizer, "CENTER")
    SizerIcon2Sd: SetSize(49,38)
    SizerIcon2Sd: SetTexCoord(154/256,252/256, 162/256,238/256)

    --Minimap: SetSize(153,153)
	Minimap: SetSize(228,228)
	Minimap: SetHitRectInsets(0, 40, 0, 0);
	Minimap: SetFrameLevel(frame:GetFrameLevel())
	Minimap: SetFrameStrata(frame:GetFrameStrata())
	Minimap: SetParent(frame)
	Minimap: ClearAllPoints()
	--Minimap: SetPoint("BOTTOMRIGHT", Anchor, "BOTTOMRIGHT", -50,50*TAN_4-18)
	Minimap: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -28,28*TAN_4-27)
	Minimap: SetScale(1)
	Minimap: SetAlpha(1)
	--MinimapCluster

	Minimap: SetMaskTexture(OW.Path("MinimapMask"))
	Minimap: SetPlayerTexture(OW.Path("MinimapArrow"))
	if not F.IsClassic then
		Minimap: SetArchBlobRingScalar(0.7) --考古超出范围白圈
		Minimap: SetQuestBlobRingScalar(0.7) --任务超出范围白圈
		Minimap: SetTaskBlobRingScalar(0.7) --任务超出范围白圈
	end

	Minimap: SetScript("OnMouseUp", function(self, button)
		Minimap:StopMovingOrSizing()
		if (button == "LeftButton") then
			Minimap_OnClick(self)
		elseif (button == "RightButton") then
			if not F.IsClassic then
				ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, -(Minimap:GetWidth()*1.2),(Minimap:GetHeight()*2))
			end
		elseif (button == "MiddleButton") then
			if not F.IsClassic then
				ToggleCalendar()
			end
		end
	end)

    F.Minimap_HideStuff()
    F.Minimap_MouseWheel()

	local Border_S = Minimap_Border_S(Anchor)
	local Border_M = Minimap_Border_M(Anchor)
	local Border_L = Minimap_Border_L(Anchor)

	local MailFrame = Mail_Template(Anchor)
	local InstanceFrame = InstanceDifficulty_Template(Anchor)
	local GarrisonFrame = Garrison_Template(Anchor)

	local IconAnchor = CreateFrame("Frame", nil, Anchor)
	IconAnchor: SetSize(12,12)

	Anchor.Sizer = Sizer
	Anchor.MinimapBorderS = Border_S
	Anchor.MinimapBorderM = Border_M
	Anchor.MinimapBorderL = Border_L
	Anchor.IconAnchor = IconAnchor

    return Anchor
end

local function Sizer_Change(frame, size)
	if size == "S" then
		--Minimap: SetSize(76,76)
		Minimap: SetScale(1/3)
		Minimap: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -(72*3),(72*TAN_4-10)*3)
		frame.MinimapBorderS: Show()
		frame.MinimapBorderM: Hide()
		frame.MinimapBorderL: Hide()
		frame.IconAnchor: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -(76+72-6),(76+72-6)*TAN_4)
	elseif size == "M" then
		--Minimap: SetSize(153,153)
		Minimap: SetScale(2/3)
		Minimap: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -(50*1.5),(50*TAN_4-17)*1.5)
		frame.MinimapBorderS: Hide()
		frame.MinimapBorderM: Show()
		frame.MinimapBorderL: Hide()
		frame.IconAnchor: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -(153+50-3),(153+50-3)*TAN_4)
	elseif size == "L" then
		--Minimap: SetSize(228,228)
		Minimap: SetScale(1)
		Minimap: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -28,28*TAN_4-26)
		frame.MinimapBorderS: Hide()
		frame.MinimapBorderM: Hide()
		frame.MinimapBorderL: Show()
		frame.IconAnchor: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -(228+28-2),(228+28-2)*TAN_4)
	end
end

local function Sizer_Update(frame, init)
	if init then
		if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Minimize then
			Sizer_Change(frame, "S")
		elseif Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Size == "L" then
			Sizer_Change(frame, "L")
		else
			Sizer_Change(frame, "M")
		end
	else
		if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Size == "M" then
			Sizer_Change(frame, "L")
			Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Size = "L"
		else
			Sizer_Change(frame, "M")
			Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Size = "M"
		end
	end
end

local function Sizer_OnClick(self, button)
	local Anchor = self:GetParent()
	if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Minimize then
		Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Minimize = false
		Sizer_Update(Anchor, true)
	elseif button == "LeftButton" then
		Sizer_Update(Anchor)
	elseif button == "RightButton" then
		Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Minimize = true
		Sizer_Update(Anchor, true)
	end
	local Zoom = Minimap:GetZoom()
	local d = Zoom-1<0 and 1 or -1
	Minimap: SetZoom(Zoom+d)
	Minimap: SetZoom(Zoom)
end

----------------------------------------------------------------
--> Icon Hold
----------------------------------------------------------------

local function Icon_Template(frame)
	local IconFrame = CreateFrame("Button", nil, frame)
	IconFrame: SetSize(83,61)
	IconFrame: SetAlpha(0.9)

	local Front = CreateFrame("Frame", nil, IconFrame)

	local Bd1 = Front: CreateTexture(nil, "BACKGROUND")
	Bd1: SetTexture(OW.Path("Minimap_Bd4"))
	Bd1: SetSize(83,61)
	Bd1: SetTexCoord(1/1024,167/1024,345/512,467/512)
	Bd1: SetAlpha(1)
	Bd1: SetVertexColor(243/255, 244/255, 246/255)
	Bd1: SetPoint("CENTER")

	local Bd1Sd = IconFrame: CreateTexture(nil, "BORDER")
	Bd1Sd: SetTexture(OW.Path("Minimap_Bd4"))
	Bd1Sd: SetSize(83,61)
	Bd1Sd: SetTexCoord(169/1024,335/1024,345/512,467/512)
	Bd1Sd: SetAlpha(0.4)
	Bd1Sd: SetVertexColor(F.Color(C.Color.Main0))
	Bd1Sd: SetPoint("CENTER")

	local Bd2 = IconFrame: CreateTexture(nil, "ARTWORK")
	Bd2: SetTexture(OW.Path("Minimap_Bd4"))
	Bd2: SetSize(83,61)
	Bd2: SetTexCoord(337/1024,503/1024,345/512,467/512)
	Bd2: SetAlpha(1)
	Bd2: SetVertexColor(243/255, 244/255, 246/255)
	Bd2: SetPoint("CENTER")

	local Bg = IconFrame: CreateTexture(nil, "BACKGROUND")
	Bg: SetTexture(OW.Path("Minimap_Bd4"))
	Bg: SetSize(83,61)
	Bg: SetTexCoord(505/1024,671/1024,345/512,467/512)
	Bg: SetAlpha(1)
	Bg: SetVertexColor(243/255, 244/255, 246/255)
	Bg: SetPoint("CENTER")

	local Icon = Front: CreateTexture(nil, "ARTWORK")
	Icon: SetSize(64,64)
	Icon: SetAlpha(1)
	Icon: SetVertexColor(F.Color(C.Color.Main0))
	Icon: SetPoint("CENTER", IconFrame, "CENTER")
	--Icon: SetRotation(rad(-4),0.5,0.5)

	IconFrame.Icon = Icon

	return IconFrame
end

local function IconHold_Frame(frame)
	local IconHold = CreateFrame("Frame", nil, frame)
	IconHold: SetSize(83,61)
	IconHold: SetPoint("BOTTOMRIGHT", frame.IconAnchor, "BOTTOMRIGHT")

	frame.IconHold = IconHold
end

----------------------------------------------------------------
--> Icons
----------------------------------------------------------------

local function MBC_SkinButton(button)
	do
		button: SetToplevel(false)
		button: ClearAllPoints()
		button: SetScale(1)
		button: SetSize(20,20)
		button: SetHitRectInsets(0,0,0,0)
		button: RegisterForDrag()
		local buttonType = button:GetObjectType()
		if button: IsMovable() then
			if button: IsUserPlaced() then
				button: SetUserPlaced(false)
			end
			button: SetMovable(false)
		end
		
		if button.dataObject then
			button: SetScript("OnEnter",function(self)
				local obj = self.dataObject
				if obj.OnTooltipShow then
					GameTooltip: SetOwner(self, "ANCHOR_NONE")
					GameTooltip: SetPoint("BOTTOMLEFT", self, "TOPRIGHT", 0,0)
					obj.OnTooltipShow(GameTooltip)
					GameTooltip: Show()
				elseif obj.OnEnter then
					obj.OnEnter(self)
				end
			end)
			button: SetScript("OnLeave", function(self)
				local obj = self.dataObject
				GameTooltip:Hide()
				if obj.OnLeave then obj.OnLeave(self) end
			end)
		else
			button: HookScript("OnEnter",function(self)
				GameTooltip: ClearAllPoints()
				GameTooltip: SetAnchorType("ANCHOR_NONE")
				GameTooltip: SetPoint("BOTTOMLEFT", self, "TOPRIGHT", 0,0)
			end)
		end
	end
	for _, region in pairs({button:GetRegions()}) do
		if region: GetObjectType() == "Texture" then
			region: Hide()
			--local file = tostring(region:GetTexture())
			--if file and ( file:find("Border") or file:find("Background") or file:find("AlphaMask") or file:find(136430) or file:find(136467) ) then
			--	region:SetTexture("")
			--end
		end
	end
	do
		local icon = button.icon or button.Icon or button.texture or _G[button.Name.."Icon"] or _G[button.Name.."_Icon"] or (buttonType == "Button" and button:GetNormalTexture())
		if icon then
			icon: Show()
			icon: ClearAllPoints()
			icon: SetPoint("CENTER")
			icon: SetSize(20,20)
			icon.ClearAllPoints = function() end
			icon.SetPoint = function() end
		end
	end
	if buttonType == "Button" then
		local highlight = button: GetHighlightTexture()
		if highlight then
			highlight: ClearAllPoints()
			highlight: SetSize(20,20)
			highlight: SetPoint("CENTER")
			highlight: SetColorTexture(1,1,1,0.5)
		end
	end
end

local function MBC_SkinSpecButton(button)
	local name = button: GetName()
	if find(name, "DBM") then
		if button.icon then
			button.icon: SetTexture(F.Path("Icons\\MBC_DBM"))
		end
	end
	if find(name, "ExorsusRaidTools") then
		if button.icon then
			button.icon: SetTexture(F.Path("Icons\\MBC_ExRT"))
		end
	end
end

local function pos_Collect(frame)
	local children = {frame: GetChildren()}
	local num = #children
	local x,y
	local Index = 0
	for i, child in ipairs(children) do
		if child.Name then
			MBC_SkinButton(child)
			MBC_SkinSpecButton(child)
			if child:IsShown() then
				Index = Index + 1
			end
			child: ClearAllPoints()
			y = ceil(Index/5) - 1
			x = Index - y*5 - 1
			child: SetPoint("CENTER", frame, "BOTTOMLEFT", 2+14+x*28, 2+14+y*28)
			child.ClearAllPoints = function() end
			child.SetPoint = function() end
		end
	end
	frame: SetSize(4+28*5,4+28*ceil(Index/5))
end

local function MBC_Refresh(frame)
		F.Minimap_CollectButtons(frame)
		pos_Collect(frame)
	end

local function MBC_Frame(frame)
	local MBC_Frame = Icon_Template(frame)
	MBC_Frame: SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
	--MBC_Frame.Icon: SetTexture(F.Path("Watcher\\Reconfigure"))
	MBC_Frame.Icon: SetTexture(OW.Path("Minimap_Icon1"))

	local MBC_Container = CreateFrame("Frame", "Quafe_Overwatch.MBCC", MBC_Frame)
	MBC_Container: SetSize(154,154)
	MBC_Container: SetPoint("BOTTOMRIGHT", MBC_Frame, "TOPRIGHT", 0,8)
	MBC_Container: SetFrameStrata("HIGH")
	MBC_Container: SetBackdropColor(F.Color(C.Color.Main0, 0.8))
	MBC_Container: Hide()

	local MBC_Backdrop = F.Create.Backdrop(MBC_Container, 2, true, 8, 8, C.Color.Main0, 0.9, C.Color.Main0, 0.9)

	MBC_Frame: RegisterEvent("PLAYER_ENTERING_WORLD")
	MBC_Frame: SetScript("OnEvent", function(self)
		--if Quafe_DB.Profile[Quafe_DBP.Profile]["Quafe_InfoBar"].MBC then
			MBC_Refresh(MBC_Container)
		--end
	end)
	
	MBC_Frame: SetScript("OnClick", function(self, button)
		if button == "LeftButton" then
			MBC_Container: SetShown(not MBC_Container:IsShown())
		else
			MBC_Refresh(MBC_Container)
		end
		GameTooltip: Hide()
	end)
end

----------------------------------------------------------------
--> Minimap Frame
----------------------------------------------------------------

local function Minimap_Frame(frame)
    local Anchor = Minimap_Template(frame)
    Anchor: SetPoint("RIGHT", frame, "RIGHT", 22,-16)

	Sizer_Update(Anchor, true)
	IconHold_Frame(Anchor)
	MBC_Frame(Anchor.IconHold)

	Anchor.Sizer: RegisterForClicks("LeftButtonUp", "RightButtonUp")
	Anchor.Sizer: SetScript("OnClick", Sizer_OnClick)
end

----------------------------------------------------------------
--> Load
----------------------------------------------------------------

local OW_MinimapFrame = CreateFrame("Frame", "Quafe_Overwatch.MinimapFrame", E)
OW_MinimapFrame: SetSize(156,170)
OW_MinimapFrame: SetFrameStrata("LOW")
OW_MinimapFrame.Init = false

F.OW_MinimapFrame_Pos = function(x,y)
	if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame and Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer then
		OW_MinimapFrame: SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -x,y)
		Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosX = -x
		Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosY = y
	end
end

local function Joystick_Update(self, elapsed)
	local x2 = Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosX
	local y2 = Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosY
	local x0,y0 = OW_MinimapFrame: GetCenter()
	local x1,y1 = self: GetCenter()
	local step = floor(1/(GetFramerate())*1e3)/1e3
	if x0 ~= x1 then
		x2 = x2 + (x1-x0)*step/2
	end
	if y0 ~= y1 then
		y2 = y2 + (y1-y0)*step/2
	end
	if not Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer then
		OW_MinimapFrame: SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", x2,y2)
		Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosX = x2
		Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosY = y2
	end
end

local function OW_MinimapFrame_Load()
	local DataBase = Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame
	if DataBase.Enable then
		OW_MinimapFrame: SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", DataBase.PosX,DataBase.PosY)
		F.CreateJoystick(OW_MinimapFrame, 156,170, "Quafe_Overwatch "..L['MINI_MAP'])
		OW_MinimapFrame.Joystick.postUpdate = Joystick_Update

    	Minimap_Frame(OW_MinimapFrame)

		if DataBase.Scale then
			OW_MinimapFrame: SetScale(DataBase.Scale)
		end

		if DataBase.SyncPlayer and Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame then
			OW_MinimapFrame: SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosX,Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosY)
			OW_MinimapFrame: SetScale(Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale)
		end

		OW_MinimapFrame.Init = true
	end
end

local function OW_MinimapFrame_Toggle(arg1, arg2)
	if arg1 == "ON" then
		if not OW_MinimapFrame.Init then
			OW_MinimapFrame_Load()
		end
		if not OW_MinimapFrame:IsShown() then
			OW_MinimapFrame: Show()
		end
	elseif arg1 == "OFF" then
		OW_MinimapFrame: Hide()
		Quafe_NoticeReload()
	elseif arg1 == "Scale" then
		if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer and Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame then
			OW_MinimapFrame: SetScale(Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale)
		else
			OW_MinimapFrame: SetScale(arg2)
		end
	elseif arg1 == "Sync" then
		if arg2 == "ON" then
			if Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame then
				OW_MinimapFrame: SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosX,Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosY)
				OW_MinimapFrame: SetScale(Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale)
			end
		elseif arg2 == "OFF" then
			OW_MinimapFrame: SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosX,Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.PosY)
			OW_MinimapFrame: SetScale(Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Scale)
		end
	end
end

local OW_MinimapFrame_Config = {
	Database = {
		["OW_MinimapFrame"] = {
			["Enable"] = true,
			["Size"] = "M",
			["Minimize"] = false,
			["PosX"] = -100,
			["PosY"] = 60,
			Scale = 1,
			SyncPlayer = true,
		},
	},

	Config = {
		Name = "Overwatch "..L['MINI_MAP'],
		Type = "Switch",
		Click = function(self, button)
			if InCombatLockdown() then return end
			if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Enable then
				Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Enable = false
				self.Text:SetText(L["OFF"])
				OW_MinimapFrame_Toggle("OFF")
			else
				Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Enable = true
				self.Text:SetText(L["ON"])
				OW_MinimapFrame_Toggle("ON")
			end
		end,
		Show = function(self)
			if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Enable then
				self.Text:SetText(L["ON"])
			else
				self.Text:SetText(L["OFF"])
			end
		end,
		Sub = {
			[1] = {
                Name = L['SCALE'],
                Type = "Slider",
                State = "ALL",
				Click = nil,
                Load = function(self)
                    self.Slider: SetMinMaxValues(0.5, 2)
					self.Slider: SetValueStep(0.05)
                    self.Slider: SetValue(Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Scale)
					self.Slider: HookScript("OnValueChanged", function(s, value)
                        value = floor(value*100+0.5)/100
						OW_MinimapFrame_Toggle("Scale", value)
                        Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.Scale = value
					end)
                end,
                Show = nil,
            },
			[2] = {
                Name = L['SYNC_WITH_PLAYERFRAME'],
                Type = "Switch",
                Click = function(self, button)
                    if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer then
                        Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer = false
                        self.Text:SetText(L["OFF"])
                        OW_MinimapFrame_Toggle("Sync", "OFF")
                    else
                        Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer = true
                        self.Text:SetText(L["ON"])
                        OW_MinimapFrame_Toggle("Sync", "ON")
                    end
                end,
                Show = function(self)
                    if Quafe_DB.Profile[Quafe_DBP.Profile].OW_MinimapFrame.SyncPlayer then
                        self.Text:SetText(L["ON"])
                    else
                        self.Text:SetText(L["OFF"])
                    end
                end,
            },
		},
	},
}

OW_MinimapFrame.Load = OW_MinimapFrame_Load
OW_MinimapFrame.Config = OW_MinimapFrame_Config
tinsert(E.Module, OW_MinimapFrame)